
import Check(check)
import Data.List(sort)

-- DList is a type for representing sets as distinct lists,
-- i.e.,  lists without duplicates

data DList a = DList [a]

empty = DList []

member x (DList xs) = x `elem` xs

insert x a@(DList xs)
  | member x a = a
  | otherwise = DList (x : xs)

remove x a@(DList xs) = case span (/= x) xs of
  (_, []) -> a
  (first, _ : last) -> DList $ first ++ last

-- Exercise 1.2

instance Show a => Show (DList a) where
  show = undefined

-- Exercise 1.3

instance Eq a => Eq (DList a) where
  (==) = undefined


-- Tests

-- note that some tests need to be changed for OLists!

tests = do
  check "show1" "{1, 2, 3, 4, 5}" (foldr insert empty [1..5])
  check "show2" "{}" (foldr insert empty ([] :: [Int]))
  check "show3" "{'c', 'b', 'a'}" (foldr insert empty "abcba")
  check "eq1" "True" (foldr insert empty ([1..5] ++ [2..4]) == foldr insert empty [5,4..1])
  check "eq2" "False" (remove 3 (foldr insert empty ([1..5] ++ [2..4])) == foldr insert empty [5,4..1])
  check "eq3" "False" (foldr insert empty ([1..5] ++ [2..4]) == remove 3 (foldr insert empty [5,4..1]))
  check "eq4" "True" (let 
    s1 = foldr insert empty [1..5];
    s2 = foldr insert empty [1..3];
    a = foldr insert empty [s1,s1,s2]
    b = foldr insert empty [s2,s1]
    in a == b)
